# -*- python -*-

from _TutorialBase import *

users = {'mod_python' : 'servlets'}

class auth2(TutorialBase):

      title = 'Basic HTTP Authentication (2 of 2)'
      css_links = ['tutorial.css']

      auth_realm = 'Mod_python Servlet Auth Tutorial'

      def auth(self):
            self._auth_with_mapping(users)

      def write_content(self):

            self.writeln(expand_codes(DIV(

                  P('''Basic HTTP Authentication is provided by
                    implementing the C{auth} method.  If the method
                    returns without exception (its return value is
                    ignored, it just needs to return) then
                    authentication is granted.  If authentication is
                    not granted it should raise
                    C{mod_python.apache.SERVER_RETURN} with
                    C{mod_python.apache.HTTP_UNAUTHORIZED} as an
                    argument.'''),

                  P('''Three helper methods are available for
                    implementing C{auth}: C{_get_user_pw},
                    C{_unauthorized} and C{_auth_with_mapping}.  See
                    the API reference for details.'''),

                  P('''This servlet uses C{_auth_with_mapping} for
                    implementing C{auth}.  This method takes a mapping
                    as its only argument with keys being usernames and
                    their values passwords.  This is the simplest way
                    of implementing C{auth}; all you need is any
                    mapping that implements the standard C{get} method
                    (like C{anydbm} module!).  This servlet also sets
                    the special instance variable C{auth_realm} which
                    sets the realm for basic HTTP authentication,
                    which most browsers display in the
                    username/password prompt.'''),

                  P('''A common question on the mod_python discussion
                    list is something along the lines of, "if someone
                    authenticates using HTTP authentication, how do I
                    log them out?"  The typical answer is, "you
                    cannot."  Which is true, but you can do clever
                    things with the C{auth} method to force someone to
                    re-login, e.g., check a timestamp you placed in a
                    cookie the first time they logged in and if it has
                    expired, force the re-login by calling
                    C{_unauthorized}.'''))))
